diff --git a/src/xdisp.c b/src/xdisp.c
index 02c5d76..641b96b 100644
--- a/src/xdisp.c
+++ b/src/xdisp.c
@@ -14162,6 +15703,19 @@ redisplay_internal (void)
 #ifdef HAVE_WINDOW_SYSTEM
 	      update_window_fringes (w, false);
 #endif
+
+/* *************************************************************************** */
+/* multiple cursors */
+
+/* NOTE:  An idle-timer function may not necessarily trigger `redisplay_window'.
+`optimization 1` (which includes left/right cursor movement on the first screen
+line), and `optimization 3` (which includes left/right cursor movement on screen
+lines subsequent to the first screen line), bypass `redisplay_window'. */
+
+      mc_remove_everything (w);
+
+/* *************************************************************************** */
+
 	      goto update;
 	    }
 	  else
@@ -14184,6 +15738,16 @@ redisplay_internal (void)
 		  && (w = XWINDOW (selected_window)) != sw)
 		goto retry;
 
+
+/* *************************************************************************** */
+/* multiple cursors */
+
+       if (mc_without_update_frame (w))
+         goto end_of_redisplay;
+
+/* *************************************************************************** */
+
+
 	      /* We used to always goto end_of_redisplay here, but this
 		 isn't enough if we have a blinking cursor.  */
 	      if (w->cursor_off_p == w->last_cursor_off_p)
@@ -14225,6 +15789,19 @@ redisplay_internal (void)
 		  *w->desired_matrix->method = 0;
 		  debug_method_add (w, "optimization 3");
 #endif
+
+/* *************************************************************************** */
+/* multiple cursors */
+
+/* NOTE:  An idle-timer function may not necessarily trigger `redisplay_window'.
+`optimization 1` (which includes left/right cursor movement on the first screen
+line), and `optimization 3` (which includes left/right cursor movement on screen
+lines subsequent to the first screen line), bypass `redisplay_window'. */
+
+      mc_remove_everything (w);
+
+/* *************************************************************************** */
+
 		  goto update;
 		}
 	      else
@@ -14358,6 +15935,18 @@ redisplay_internal (void)
 		    unrequest_sigio ();
 		  STOP_POLLING;
 
+/* *************************************************************************** */
+/* multiple cursors */
+
+    /* On Emacs for Windows, crosshairs will not draw at the beginning of the buffer
+    without this condition when the idle-timer switches are toggled.  This may have
+    been due to the parentheses overlays that were removed and did not need to be
+    redrawn since opening parentheses at the beginning of the buffer are not highlighted. */
+    if (w->mc.draw_crosshairs)
+      w->must_be_updated_p = true;
+
+/* *************************************************************************** */
+
 		  pending |= update_frame (f, false, false);
 		  f->cursor_type_changed = false;
 		  f->updated_p = true;
@@ -17564,6 +19153,20 @@ redisplay_window (Lisp_Object window, bool just_this_one_p)
   else
     TEMP_SET_PT_BOTH (CHARPOS (opoint), BYTEPOS (opoint));
 
+/* *************************************************************************** */
+/* BEGIN multiple cursors */
+
+/* NOTE:  An idle-timer function may not necessarily trigger `redisplay_window'.
+`optimization 1` (which includes left/right cursor movement on the first screen
+line), and `optimization 3` (which includes left/right cursor movement on screen
+lines subsequent to the first screen line), bypass `redisplay_window'. */
+
+  mc_record_x_wstart_wend (w);
+
+  mc_remove_everything (w);
+
+/* *************************************************************************** */
+
   set_buffer_internal_1 (old);
   /* Avoid an abort in TEMP_SET_PT_BOTH if the buffer has become
      shorter.  This can be caused by log truncation in *Messages*.  */
@@ -24608,6 +26211,25 @@ decode_mode_spec (struct window *w, register int c, int field_width,
 	  return "@";
       }
 
+/* *************************************************************************** */
+/* multiple cursors */
+
+    case 'w':
+      {
+  ptrdiff_t window_start = marker_position (w->start);
+  pint2str (decode_mode_spec_buf, width, window_start);
+  return decode_mode_spec_buf;
+      }
+
+    case 'W':
+      {
+  ptrdiff_t window_end = BUF_Z (b) - w->window_end_pos;
+  pint2str (decode_mode_spec_buf, width, window_end);
+  return decode_mode_spec_buf;
+      }
+
+/* *************************************************************************** */
+
     case 'z':
       /* coding-system (not including end-of-line format) */
     case 'Z':
@@ -29468,9 +31090,19 @@ display_and_set_cursor (struct window *w, bool on,
       w->phys_cursor.vpos = vpos;
     }
 
-  FRAME_RIF (f)->draw_window_cursor (w, glyph_row, x, y,
-                                     new_cursor_type, new_cursor_width,
-                                     on, active_cursor);
+/* *************************************************************************** */
+/* multiple cursors */
+
+  Lisp_Object color_vector = (Fmake_vector (make_number (3), Qnil));
+  ASET (color_vector, 0, make_float (-1.0));
+  ASET (color_vector, 1, make_float (-1.0));
+  ASET (color_vector, 2, make_float (-1.0));
+   FRAME_RIF (f)->draw_window_cursor (w, glyph_row, x, y,
+                                      new_cursor_type, new_cursor_width,
+                                     on, active_cursor, color_vector, Qnil);
+
+/* *************************************************************************** */
+
 }
 
 
@@ -29502,10 +31134,28 @@ update_window_cursor (struct window *w, bool on)
       if (row->reversed_p && hpos >= row->used[TEXT_AREA])
 	hpos = row->used[TEXT_AREA] - 1;
 
-      block_input ();
-      display_and_set_cursor (w, on, hpos, vpos,
+/* *************************************************************************** */
+/* multiple cursors */
+
+      /* Moving the mouse triggers `update_window_cursor' which calls
+      `display_and_set_cursor' that would otherwise remove a portion of the
+      horizontal ruler from point at end of visual line to window edge. */
+      bool crosshairs_p = (!MINI_WINDOW_P (w)
+                           && !w->mc.draw_crosshairs
+                           && !NILP (w->crosshairs_cache)
+                           && !NILP (BVAR (XBUFFER (w->contents), crosshairs))
+                           && w == XWINDOW (XCAR (Fnth (make_number (1), w->crosshairs_cache)))
+                           && EQ (w->contents, XCAR (Fnth (make_number (2), w->crosshairs_cache))));
+      if (!crosshairs_p)
+        {
+       block_input ();
+       display_and_set_cursor (w, on, hpos, vpos,
 			      w->phys_cursor.x, w->phys_cursor.y);
-      unblock_input ();
+       unblock_input ();
+        }
+
+/* *************************************************************************** */
+
     }
 }
 
@@ -32216,6 +33866,26 @@ x_intersect_rectangles (XRectangle *r1, XRectangle *r2, XRectangle *result)
 void
 syms_of_xdisp (void)
 {
+
+/* *************************************************************************** */
+/* BEGIN multiple cursors */
+
+  DEFSYM (Qmc_glyph, "mc-glyph-cursor");
+  DEFSYM (Qmc_glyphless, "mc-glypless-cursor");
+  DEFSYM (Qmc_glyph_tab, "mc-glyph-tab");
+
+  defsubr (&Smc_activate_cursors);
+  DEFSYM (Qmc_activate_cursors, "mc-activate-cursors");
+
+  defsubr (&Smc_activate_crosshairs);
+  DEFSYM (Qmc_activate_crosshairs, "mc-activate-crosshairs");
+
+  defsubr (&Sbug_28936);
+  DEFSYM (Qbug_28936, "bug-28936");
+
+/* END multiple cursors */
+/* *************************************************************************** */
+
   Vwith_echo_area_save_vector = Qnil;
   staticpro (&Vwith_echo_area_save_vector);
 
diff --git a/src/xterm.c b/src/xterm.c
index 1b45cf1..f2a3cb7 100644
--- a/src/xterm.c
+++ b/src/xterm.c
@@ -1163,10 +1163,12 @@ x_update_window_end (struct window *w, bool cursor_on_p,
     {
       block_input ();
 
-      if (cursor_on_p)
-	display_and_set_cursor (w, true,
-				w->output_cursor.hpos, w->output_cursor.vpos,
-				w->output_cursor.x, w->output_cursor.y);
+/* *************************************************************************** */
+/* multiple cursors */
+
+      mc_portal (w, cursor_on_p);
+
+/* *************************************************************************** */
 
       if (draw_window_fringes (w, true))
 	{
@@ -1550,10 +1552,17 @@ static void x_check_font (struct frame *, struct font *);
 static void
 x_set_cursor_gc (struct glyph_string *s)
 {
-  if (s->font == FRAME_FONT (s->f)
+/* *************************************************************************** */
+/* multiple cursors */
+
+  struct window *w = decode_live_window (selected_window);
+  if ((s->font == FRAME_FONT (s->f)
       && s->face->background == FRAME_BACKGROUND_PIXEL (s->f)
       && s->face->foreground == FRAME_FOREGROUND_PIXEL (s->f)
       && !s->cmp)
+      || w->mc.cursor_gc_default)
+
+/* *************************************************************************** */
     s->gc = s->f->output_data.x->cursor_gc;
   else
     {
@@ -9310,7 +9319,16 @@ x_draw_bar_cursor (struct window *w, struct glyph_row *row, int width, enum text
 	 invisible.  Use the glyph's foreground color instead in this
 	 case, on the assumption that the glyph's colors are chosen so
 	 that the glyph is legible.  */
-      if (face->background == f->output_data.x->cursor_pixel)
+
+/* *************************************************************************** */
+/* multiple cursors */
+
+      if (face->background == f->output_data.x->cursor_pixel
+          && !w->mc.cursor_gc_invisible_okay)
+
+
+/* *************************************************************************** */
+
 	xgcv.background = xgcv.foreground = face->foreground;
       else
 	xgcv.background = xgcv.foreground = f->output_data.x->cursor_pixel;
@@ -9398,7 +9416,13 @@ x_clear_frame_area (struct frame *f, int x, int y, int width, int height)
 static void
 x_draw_window_cursor (struct window *w, struct glyph_row *glyph_row, int x,
 		      int y, enum text_cursor_kinds cursor_type,
-		      int cursor_width, bool on_p, bool active_p)
+/* *************************************************************************** */
+/* multiple cursors */
+
+  int cursor_width, bool on_p, bool active_p,
+  Lisp_Object color_vector, Lisp_Object flavor)
+
+/* *************************************************************************** */
 {
   struct frame *f = XFRAME (WINDOW_FRAME (w));
 
@@ -9417,31 +9441,124 @@ x_draw_window_cursor (struct window *w, struct glyph_row *glyph_row, int x,
 	}
       else
 	{
-	  switch (cursor_type)
-	    {
-	    case HOLLOW_BOX_CURSOR:
-	      x_draw_hollow_cursor (w, glyph_row);
-	      break;
 
-	    case FILLED_BOX_CURSOR:
-	      draw_phys_cursor_glyph (w, glyph_row, DRAW_CURSOR);
-	      break;
-
-	    case BAR_CURSOR:
-	      x_draw_bar_cursor (w, glyph_row, cursor_width, BAR_CURSOR);
-	      break;
-
-	    case HBAR_CURSOR:
-	      x_draw_bar_cursor (w, glyph_row, cursor_width, HBAR_CURSOR);
-	      break;
-
-	    case NO_CURSOR:
-	      w->phys_cursor_width = 0;
-	      break;
+/* *************************************************************************** */
+/* BEGIN multiple cursors */
+  double red = XFLOAT_DATA (AREF (color_vector, 0));
+  double green = XFLOAT_DATA (AREF (color_vector, 1));
+  double blue = XFLOAT_DATA (AREF (color_vector, 2));
+  switch (cursor_type)
+  {
+    case HOLLOW_BOX_CURSOR:
+    {
+      if (red >= 0 && blue >= 0 && green >= 0)
+        /* Temporarily hijack `f->output_data.x->cursor_pixel'.  */
+        {
+          struct frame *f = XFRAME (WINDOW_FRAME (w));
+          struct x_display_info *dpyinfo = FRAME_DISPLAY_INFO (f);
+          unsigned long orig_val = f->output_data.x->cursor_pixel;
+          int int_red = red * 65535;
+          int int_green = green * 65535;
+          int int_blue = blue * 65535;
+          f->output_data.x->cursor_pixel = x_make_truecolor_pixel (dpyinfo, int_red, int_green, int_blue);
+          x_draw_hollow_cursor (w, glyph_row);
+          f->output_data.x->cursor_pixel = orig_val;
+        }
+        else
+          x_draw_hollow_cursor (w, glyph_row);
+      break;
+    }
+    case FILLED_BOX_CURSOR:
+    {
+      if (red >= 0 && blue >= 0 && green >= 0)
+        /* Temporarily hijack `f->output_data.x->cursor_gc' by borrowing the
+        functionality of `x_make_gc' in xfns.c.  */
+        {
+          block_input ();
+          Lisp_Object window = (selected_window);
+          struct window *w = decode_live_window (window);
+          struct frame *f = XFRAME (WINDOW_FRAME (w));
+          struct x_display_info *dpyinfo = FRAME_DISPLAY_INFO (f);
+          int int_red = red * 65535;
+          int int_green = green * 65535;
+          int int_blue = blue * 65535;
+          XGCValues gc_values;
+          unsigned long mask = GCForeground | GCBackground | GCFillStyle | GCLineWidth;
+          unsigned long orig_val_a = FRAME_BACKGROUND_PIXEL (f);
+          unsigned long orig_val_b = f->output_data.x->cursor_pixel;
+          gc_values.line_width = 0;  /* Means 1 using fast algorithm.  */
+          gc_values.foreground = FRAME_BACKGROUND_PIXEL (f);
+          gc_values.background = x_make_truecolor_pixel (dpyinfo, int_red, int_green, int_blue);
+          gc_values.fill_style = FillOpaqueStippled;
+          f->output_data.x->cursor_gc
+            = XCreateGC (FRAME_X_DISPLAY (f), FRAME_X_WINDOW (f), mask, &gc_values);
+          /* Force `x_set_cursor_gc' to use `s->f->output_data.x->cursor_gc'.  */
+          w->mc.cursor_gc_default = true;
+          draw_phys_cursor_glyph (w, glyph_row, DRAW_CURSOR);
+          w->mc.cursor_gc_default = false;
+          gc_values.line_width = 0;  /* Means 1 using fast algorithm.  */
+          gc_values.foreground = orig_val_a;
+          gc_values.background = orig_val_b;
+          gc_values.fill_style = FillOpaqueStippled;
+          f->output_data.x->cursor_gc
+            = XCreateGC (FRAME_X_DISPLAY (f), FRAME_X_WINDOW (f), mask, &gc_values);
+          unblock_input ();
+        }
+        else
+          draw_phys_cursor_glyph (w, glyph_row, DRAW_CURSOR);
+      break;
+    }
+    case BAR_CURSOR:
+    {
+      if (red >= 0 && blue >= 0 && green >= 0)
+        /* Temporarily hijack `f->output_data.x->cursor_pixel'.  */
+        {
+          struct frame *f = XFRAME (WINDOW_FRAME (w));
+          struct x_display_info *dpyinfo = FRAME_DISPLAY_INFO (f);
+          unsigned long orig_val = f->output_data.x->cursor_pixel;
+          int int_red = red * 65535;
+          int int_green = green * 65535;
+          int int_blue = blue * 65535;
+          f->output_data.x->cursor_pixel = x_make_truecolor_pixel (dpyinfo, int_red, int_green, int_blue);
+          w->mc.cursor_gc_invisible_okay = true;
+          x_draw_bar_cursor (w, glyph_row, cursor_width, BAR_CURSOR);
+          w->mc.cursor_gc_invisible_okay = false;
+          f->output_data.x->cursor_pixel = orig_val;
+        }
+        else
+          x_draw_bar_cursor (w, glyph_row, cursor_width, BAR_CURSOR);
+      break;
+    }
+    case HBAR_CURSOR:
+    {
+      if (red >= 0 && blue >= 0 && green >= 0)
+        /* Temporarily hijack `f->output_data.x->cursor_pixel'.  */
+        {
+          struct frame *f = XFRAME (WINDOW_FRAME (w));
+          struct x_display_info *dpyinfo = FRAME_DISPLAY_INFO (f);
+          unsigned long orig_val = f->output_data.x->cursor_pixel;
+          int int_red = red * 65535;
+          int int_green = green * 65535;
+          int int_blue = blue * 65535;
+          f->output_data.x->cursor_pixel = x_make_truecolor_pixel (dpyinfo, int_red, int_green, int_blue);
+          w->mc.cursor_gc_invisible_okay = true;
+          x_draw_bar_cursor (w, glyph_row, cursor_width, HBAR_CURSOR);
+          w->mc.cursor_gc_invisible_okay = false;
+          f->output_data.x->cursor_pixel = orig_val;
+        }
+        else
+          x_draw_bar_cursor (w, glyph_row, cursor_width, HBAR_CURSOR);
+      break;
+    }
+    case NO_CURSOR:
+      w->phys_cursor_width = 0;
+      break;
+    default:
+      emacs_abort ();
+  }
+/* END multiple cursors */
+/* *************************************************************************** */
 
-	    default:
-	      emacs_abort ();
-	    }
 	}
 
 #ifdef HAVE_X_I18N
